From 439ff094ce0d1be5704d52bc445a22c1be01ab0d Mon Sep 17 00:00:00 2001
From: Patrick Griffis <tingping@tingping.se>
Date: Sun, 26 Jun 2016 14:37:25 -0400
Subject: [PATCH] Fix building against openssl 1.1.0

Fixes #1759
---
 configure.ac        |  2 +-
 src/common/server.c | 16 ++++++++++------
 2 files changed, 11 insertions(+), 7 deletions(-)

#diff --git a/configure.ac b/configure.ac
#index ec6e24012..2c60a4847 100644
#--- a/configure.ac
#+++ b/configure.ac
#@@ -373,7 +373,7 @@ dnl *********************************************************************
# 
# 
# AS_IF([test "$openssl" != no], [
#-	PKG_CHECK_MODULES(OPENSSL, [openssl], [
#+	PKG_CHECK_MODULES(OPENSSL, [openssl >= 0.9.8], [
# 		AC_DEFINE(USE_OPENSSL)
# 		openssl=yes
# 		COMMON_LIBS="$COMMON_LIBS $OPENSSL_LIBS"
Index: xchat-2.8.8/src/common/server.c
===================================================================
--- xchat-2.8.8.orig/src/common/server.c
+++ xchat-2.8.8/src/common/server.c
@@ -596,19 +596,22 @@
 	char subject[256];
 	char issuer[256];
 	char buf[512];
+	X509 *current_cert = X509_STORE_CTX_get_current_cert (ctx);
 
+	if (!current_cert)
+		return TRUE;
 
-	X509_NAME_oneline (X509_get_subject_name (ctx->current_cert), subject,
-							 sizeof (subject));
-	X509_NAME_oneline (X509_get_issuer_name (ctx->current_cert), issuer,
-							 sizeof (issuer));
+	X509_NAME_oneline (X509_get_subject_name (current_cert),
+	                   subject, sizeof (subject));
+	X509_NAME_oneline (X509_get_issuer_name (current_cert),
+	                   issuer, sizeof (issuer));
 
 	snprintf (buf, sizeof (buf), "* Subject: %s", subject);
 	EMIT_SIGNAL (XP_TE_SSLMESSAGE, g_sess, buf, NULL, NULL, NULL, 0);
 	snprintf (buf, sizeof (buf), "* Issuer: %s", issuer);
 	EMIT_SIGNAL (XP_TE_SSLMESSAGE, g_sess, buf, NULL, NULL, NULL, 0);
 
-	return (TRUE);					  /* always ok */
+	return TRUE;
 }
 
 static int
@@ -751,7 +754,8 @@
 		return (0);					  /* remove it (0) */
 	} else
 	{
-		if (serv->ssl->session && serv->ssl->session->time + SSLTMOUT < time (NULL))
+		SSL_SESSION *session = SSL_get_session (serv->ssl);
+		if (session && SSL_SESSION_get_time (session) + SSLTMOUT < time (NULL))
 		{
 			snprintf (buf, sizeof (buf), "SSL handshake timed out");
 			EMIT_SIGNAL (XP_TE_CONNFAIL, serv->server_session, buf, NULL,
Origin: https://github.com/hexchat/hexchat/commit/15600f405f2d5bda6ccf0dd73957395716e0d4d3
Description: Fix CVE-2016-2087

--- xchat-2.8.8.orig/src/common/text.c
+++ xchat-2.8.8/src/common/text.c
@@ -63,12 +63,14 @@ scrollback_get_filename (session *sess,
 	if (!net)
 		return NULL;
 
+	net = log_create_filename (net);
 	snprintf (buf, max, "%s/scrollback/%s/%s.txt", get_xdir_fs (), net, "");
 	mkdir_p (buf);
 
 	chan = log_create_filename (sess->channel);
 	snprintf (buf, max, "%s/scrollback/%s/%s.txt", get_xdir_fs (), net, chan);
 	free (chan);
+	free (net);
 
 	return buf;
 }
Origin: https://github.com/hexchat/hexchat/commit/c99f2ba645d1f4d01d6d2bb0cc1238825e15c604
Description: Fix CVE-2013-7449

--- xchat-2.8.8.orig/src/common/server.c
+++ xchat-2.8.8/src/common/server.c
@@ -717,9 +717,22 @@ ssl_do_connect (server * serv)
 		switch (verify_error)
 		{
 		case X509_V_OK:
+			{
+				X509 *cert = SSL_get_peer_certificate (serv->ssl);
+				int hostname_err;
+				if ((hostname_err = _SSL_check_hostname(cert, serv->hostname)) != 0)
+				{
+					snprintf (buf, sizeof (buf), "* Verify E: Failed to validate hostname? (%d)%s",
+							 hostname_err, serv->accept_invalid_cert ? " -- Ignored" : "");
+					if (serv->accept_invalid_cert)
+						EMIT_SIGNAL (XP_TE_SSLMESSAGE, serv->server_session, buf, NULL, NULL, NULL, 0);
+					else
+						goto conn_fail;
+				}
+				break;
+			}
 			/* snprintf (buf, sizeof (buf), "* Verify OK (?)"); */
 			/* EMIT_SIGNAL (XP_TE_SSLMESSAGE, serv->server_session, buf, NULL, NULL, NULL, 0); */
-			break;
 		case X509_V_ERR_UNABLE_TO_GET_ISSUER_CERT_LOCALLY:
 		case X509_V_ERR_UNABLE_TO_VERIFY_LEAF_SIGNATURE:
 		case X509_V_ERR_DEPTH_ZERO_SELF_SIGNED_CERT:
@@ -738,6 +751,7 @@ ssl_do_connect (server * serv)
 			snprintf (buf, sizeof (buf), "%s.? (%d)",
 						 X509_verify_cert_error_string (verify_error),
 						 verify_error);
+conn_fail:
 			EMIT_SIGNAL (XP_TE_CONNFAIL, serv->server_session, buf, NULL, NULL,
 							 NULL, 0);
 
--- xchat-2.8.8.orig/src/common/ssl.c
+++ xchat-2.8.8/src/common/ssl.c
@@ -19,11 +19,13 @@
 
 #include <openssl/ssl.h>		  /* SSL_() */
 #include <openssl/err.h>		  /* ERR_() */
+#include <openssl/x509v3.h>
 #include <time.h>					  /* asctime() */
 #include <string.h>				  /* strncpy() */
 #include "ssl.h"					  /* struct cert_info */
 #include "inet.h"
 #include "../../config.h"		  /* HAVE_SNPRINTF */
+#include <gio/gio.h>
 
 #ifndef HAVE_SNPRINTF
 #define snprintf g_snprintf
@@ -335,3 +337,204 @@ _SSL_close (SSL * ssl)
 	SSL_free (ssl);
 	ERR_remove_state (0);		  /* free state buffer */
 }
+
+/* Hostname validation code based on OpenBSD's libtls. */
+
+static int
+_SSL_match_hostname (const char *cert_hostname, const char *hostname)
+{
+	const char *cert_domain, *domain, *next_dot;
+
+	if (g_ascii_strcasecmp (cert_hostname, hostname) == 0)
+		return 0;
+
+	/* Wildcard match? */
+	if (cert_hostname[0] == '*')
+	{
+		/*
+		 * Valid wildcards:
+		 * - "*.domain.tld"
+		 * - "*.sub.domain.tld"
+		 * - etc.
+		 * Reject "*.tld".
+		 * No attempt to prevent the use of eg. "*.co.uk".
+		 */
+		cert_domain = &cert_hostname[1];
+		/* Disallow "*"  */
+		if (cert_domain[0] == '\0')
+			return -1;
+		/* Disallow "*foo" */
+		if (cert_domain[0] != '.')
+			return -1;
+		/* Disallow "*.." */
+		if (cert_domain[1] == '.')
+			return -1;
+		next_dot = strchr (&cert_domain[1], '.');
+		/* Disallow "*.bar" */
+		if (next_dot == NULL)
+			return -1;
+		/* Disallow "*.bar.." */
+		if (next_dot[1] == '.')
+			return -1;
+
+		domain = strchr (hostname, '.');
+
+		/* No wildcard match against a hostname with no domain part. */
+		if (domain == NULL || strlen(domain) == 1)
+			return -1;
+
+		if (g_ascii_strcasecmp (cert_domain, domain) == 0)
+			return 0;
+	}
+
+	return -1;
+}
+
+static int
+_SSL_check_subject_altname (X509 *cert, const char *host)
+{
+	STACK_OF(GENERAL_NAME) *altname_stack = NULL;
+	GInetAddress *addr;
+	GSocketFamily family;
+	int type = GEN_DNS;
+	int count, i;
+	int rv = -1;
+
+	altname_stack = X509_get_ext_d2i (cert, NID_subject_alt_name, NULL, NULL);
+	if (altname_stack == NULL)
+		return -1;
+
+	addr = g_inet_address_new_from_string (host);
+	if (addr != NULL)
+	{
+		family = g_inet_address_get_family (addr);
+		if (family == G_SOCKET_FAMILY_IPV4 || family == G_SOCKET_FAMILY_IPV6)
+			type = GEN_IPADD;
+	}
+
+	count = sk_GENERAL_NAME_num(altname_stack);
+	for (i = 0; i < count; i++)
+	{
+		GENERAL_NAME *altname;
+
+		altname = sk_GENERAL_NAME_value (altname_stack, i);
+
+		if (altname->type != type)
+			continue;
+
+		if (type == GEN_DNS)
+		{
+			unsigned char *data;
+			int format;
+
+			format = ASN1_STRING_type (altname->d.dNSName);
+			if (format == V_ASN1_IA5STRING)
+			{
+				data = ASN1_STRING_data (altname->d.dNSName);
+
+				if (ASN1_STRING_length (altname->d.dNSName) != (int)strlen(data))
+				{
+					g_warning("NUL byte in subjectAltName, probably a malicious certificate.\n");
+					rv = -2;
+					break;
+				}
+
+				if (_SSL_match_hostname (data, host) == 0)
+				{
+					rv = 0;
+					break;
+				}
+			}
+			else
+				g_warning ("unhandled subjectAltName dNSName encoding (%d)\n", format);
+
+		}
+		else if (type == GEN_IPADD)
+		{
+			unsigned char *data;
+			const guint8 *addr_bytes;
+			int datalen, addr_len;
+
+			datalen = ASN1_STRING_length (altname->d.iPAddress);
+			data = ASN1_STRING_data (altname->d.iPAddress);
+
+			addr_bytes = g_inet_address_to_bytes (addr);
+			addr_len = (int)g_inet_address_get_native_size (addr);
+
+			if (datalen == addr_len && memcmp (data, addr_bytes, addr_len) == 0)
+			{
+				rv = 0;
+				break;
+			}
+		}
+	}
+
+	if (addr != NULL)
+		g_object_unref (addr);
+	sk_GENERAL_NAME_free (altname_stack);
+	return rv;
+}
+
+static int
+_SSL_check_common_name (X509 *cert, const char *host)
+{
+	X509_NAME *name;
+	char *common_name = NULL;
+	int common_name_len;
+	int rv = -1;
+	GInetAddress *addr;
+
+	name = X509_get_subject_name (cert);
+	if (name == NULL)
+		return -1;
+
+	common_name_len = X509_NAME_get_text_by_NID (name, NID_commonName, NULL, 0);
+	if (common_name_len < 0)
+		return -1;
+
+	common_name = calloc (common_name_len + 1, 1);
+	if (common_name == NULL)
+		return -1;
+
+	X509_NAME_get_text_by_NID (name, NID_commonName, common_name, common_name_len + 1);
+
+	/* NUL bytes in CN? */
+	if (common_name_len != (int)strlen(common_name))
+	{
+		g_warning ("NUL byte in Common Name field, probably a malicious certificate.\n");
+		rv = -2;
+		goto out;
+	}
+
+	if ((addr = g_inet_address_new_from_string (host)) != NULL)
+	{
+		/*
+		 * We don't want to attempt wildcard matching against IP
+		 * addresses, so perform a simple comparison here.
+		 */
+		if (g_strcmp0 (common_name, host) == 0)
+			rv = 0;
+		else
+			rv = -1;
+
+		g_object_unref (addr);
+	}
+	else if (_SSL_match_hostname (common_name, host) == 0)
+		rv = 0;
+
+out:
+	free(common_name);
+	return rv;
+}
+
+int
+_SSL_check_hostname (X509 *cert, const char *host)
+{
+	int rv;
+
+	rv = _SSL_check_subject_altname (cert, host);
+	if (rv == 0 || rv == -2)
+		return rv;
+
+	return _SSL_check_common_name (cert, host);
+}
--- xchat-2.8.8.orig/src/common/ssl.h
+++ xchat-2.8.8/src/common/ssl.h
@@ -34,7 +34,7 @@ char *_SSL_set_verify (SSL_CTX *ctx, voi
     int SSL_get_fd(SSL *);
 */
 void _SSL_close (SSL * ssl);
-
+int _SSL_check_hostname(X509 *cert, const char *host);
 int _SSL_get_cert_info (struct cert_info *cert_info, SSL * ssl);
 struct chiper_info *_SSL_get_cipher_info (SSL * ssl);
 
Description: Use unicode by default
Author: Gianfranco Costamagna <locutusofborg@debian.org>
Last-Update: 2017-08-09

--- xchat-2.8.8.orig/src/common/servlist.c
+++ xchat-2.8.8/src/common/servlist.c
@@ -932,7 +932,7 @@ servlist_load_defaults (void)
 		if (def[i].network)
 		{
 			net = servlist_net_add (def[i].network, def[i].host, FALSE);
-			net->encoding = strdup ("IRC (Latin/Unicode Hybrid)");
+			net->encoding = strdup ("UTF-8 (Unicode)");
 			if (def[i].channel)
 				net->autojoin = strdup (def[i].channel);
 			if (def[i].charset)
--- xchat-2.8.8.orig/src/fe-gtk/servlistgui.c
+++ xchat-2.8.8/src/fe-gtk/servlistgui.c
@@ -267,7 +267,7 @@ servlist_addnet_cb (GtkWidget *item, Gtk
 	ircnet *net;
 
 	net = servlist_net_add (_("New Network"), "", TRUE);
-	net->encoding = strdup ("IRC (Latin/Unicode Hybrid)");
+	net->encoding = strdup ("UTF-8 (Unicode)");
 	servlist_server_add (net, "newserver/6667");
 
 	store = (GtkListStore *)gtk_tree_view_get_model (treeview);
## 01_serverlist.dpatch by evo, edited by bartm, edited by asisak, edited by
## warp10, ember
##
## DP: Add debian and chillfactory irc servers.
## DP: Make Debian servers default.
## DP: Remove Aitvaras IPV6 servers
## DP: Connect irc.ubuntu.com and irc.freelists.org to port 8001.
## DP: Fix oz.org referred as "OzNet" and conncting to wrong servers.
## DP: Refresh patch for 2.8.6

diff -urNad xchat-2.8.6~/src/common/servlist.c xchat-2.8.6/src/common/servlist.c
--- xchat-2.8.6~/src/common/servlist.c	2008-04-01 09:22:34.000000000 +0100
+++ xchat-2.8.6/src/common/servlist.c	2008-06-22 13:27:45.000000000 +0100
@@ -46,6 +46,12 @@
 
 static const struct defaultserver def[] =
 {
+	{"Debian Servers", 0, "#debian"},
+	{0,                     "irc.debian.org"},
+
+	{"Ubuntu Servers", 0, "#ubuntu"},
+	{0,                     "irc.ubuntu.com/8001"},
+
 	{"2600net",	0},
 	{0,			"irc.2600.net"},
 
@@ -59,12 +65,12 @@
 	{0,			"eu.afternet.org"},
 
 	{"Aitvaras",	0},
-#ifdef USE_IPV6
+/*#ifdef USE_IPV6
 #ifdef USE_OPENSSL
 	{0,			"irc6.ktu.lt/+7668"},
 #endif
 	{0,			"irc6.ktu.lt/7666"},
-#endif
+#endif*/
 #ifdef USE_OPENSSL
 	{0,			"irc.data.lt/+6668"},
 	{0,			"irc-ssl.omnitel.net/+6668"},
@@ -137,6 +143,9 @@
 	{"ChatSpike", 0},
 	{0,			"irc.chatspike.net"},
 
+	{"ChillFactory", 0},
+	{0,                     "irc.chillfactory.net"},
+
 	{"CoolChat",	0},
 	{0,			"irc.coolchat.net"},
 /*	{0,			"unix.coolchat.net"},
@@ -207,7 +216,7 @@
 	{0,			"irc.vendetta.com"},
 
 	{"FreeNode",	0},
-	{0,				"irc.freenode.net"},
+	{0,				"irc.freenode.net/8001"},
 
 /*	{"Freeworld",	0},
 	{0,			"kabel.freeworld.nu"},
@@ -339,7 +348,14 @@
 
 	{"OzNet",	0},
 	{0,			"irc.oz.org"},
-
+	{0,			"germany.oz.org"},
+	{0,			"sandiego.oz.org"},
+	{0,			"us.oz.org"},
+	{0,			"au.oz.org"},
+	{0,			"rockhampton.oz.org"},
+	{0,			"wollongong.oz.org"},
+	{0,			"waix.oz.org"},	
+	
 	{"PTlink",	0},
 	{0,			"irc.PTlink.net"},
 	{0,			"aaia.PTlink.net"},
@@ -900,7 +916,7 @@
 				free (net->encoding);
 				net->encoding = strdup (def[i].charset);
 			}
-			if (g_str_hash (def[i].network) == 0x8e1b96f7)
+			if (g_str_hash (def[i].network) == 0x37473b25)
 				prefs.slist_select = j;
 			j++;
 		} else
## 10_fix_unchecked_mallocs.dpatch by Paul Wise <pabs3@bonedaddy.net>
##
## DP: Fix unchecked mallocs throughout the source code.
--- a/src/common/xchat.c
+++ b/src/common/xchat.c
@@ -342,6 +342,8 @@
 	session *sess;
 
 	sess = malloc (sizeof (struct session));
+	if(sess == NULL)
+		return NULL;
 	memset (sess, 0, sizeof (struct session));
 
 	sess->server = serv;
## 20_url_pattern.dpatch by ???
##
## DP: Fix url patterns
--- a/src/fe-gtk/xtext.c
+++ b/src/fe-gtk/xtext.c
@@ -1868,7 +1868,9 @@
 		len++;
 	}
 
-	if (len > 0 && word[len-1]=='.')
+	/* ignore trailing dots and commas. */
+	/* FIXME: locales? */
+	while (len > 0 && (word[len-1]=='.' || word[len-1]==',' || word[len-1]==';'))
 	{
 		len--;
 		str--;
## 41_casecomp.dpatch by ???
##
## DP: Downloaded from http://www.phys.ethz.ch/~mweyland/casecomp.patch
## DP: this will modify tab completion so that uppercase letters will
## DP: only match to uppercase, while lowercase match bot
--- a/src/common/cfgfiles.c
+++ b/src/common/cfgfiles.c
@@ -387,6 +387,8 @@
 	{"completion_sort", P_OFFINT (completion_sort), TYPE_INT},
 	{"completion_suffix", P_OFFSET (nick_suffix), TYPE_STR},
 
+	{"completion_cinsens", P_OFFINT (completion_cinsens), TYPE_BOOL},
+
 	{"dcc_auto_chat", P_OFFINT (autodccchat), TYPE_INT},
 	{"dcc_auto_resume", P_OFFINT (autoresume), TYPE_BOOL},
 	{"dcc_auto_send", P_OFFINT (autodccsend), TYPE_INT},
--- a/src/common/util.c
+++ b/src/common/util.c
@@ -1350,7 +1350,7 @@
 	register unsigned char *s2 = (unsigned char *) str2;
 	register int res;
 
-	while ((res = rfc_tolower (*s1) - rfc_tolower (*s2)) == 0)
+	while ((res = hal_casecomp(s1,s2)) == 0)
 	{
 		s1++;
 		s2++;
@@ -1361,6 +1361,25 @@
 	return (res);
 }
 
+int
+hal_casecomp ( char *s1, char *s2)
+{
+
+/* This function, called by rfc_ncasecmp, enables enhanced tab
+ * completition: It completes te<tab> to Test but not Te<tab> to
+ * test2. (This is useful if you have two users Test1 and test2 in
+ * the channel. Can be toggeled wit /set completion_cinsens (0|1)
+ *
+ *  -- Mathias Weyland <mathias@weyland.ch>, 6.9.2004
+*/
+	if((*s2 - rfc_tolower (*s2)) || prefs.completion_cinsens)
+	{
+		return (rfc_tolower (*s1) - rfc_tolower (*s2));
+	} else {
+		return (*s1 - *s2);
+	}
+}
+
 const unsigned char rfc_tolowertab[] =
 	{ 0, 0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8, 0x9, 0xa,
 	0xb, 0xc, 0xd, 0xe, 0xf, 0x10, 0x11, 0x12, 0x13, 0x14,
--- a/src/common/util.h
+++ b/src/common/util.h
@@ -26,6 +26,7 @@
 void for_files (char *dirname, char *mask, void callback (char *file));
 int rfc_casecmp (const char *, const char *);
 int rfc_ncasecmp (char *, char *, int);
+int hal_casecomp ( char *s1, char *s2);
 int buf_get_line (char *, char **, int *, int len);
 char *nocasestrstr (const char *text, const char *tofind);
 char *country (char *);
--- a/src/common/xchat.h
+++ b/src/common/xchat.h
@@ -214,6 +214,7 @@
 	unsigned int userlistbuttons;
 	unsigned int showhostname_in_userlist;
 	unsigned int nickcompletion;
+	unsigned int completion_cinsens;
 	unsigned int completion_amount;
 	unsigned int tabchannels;
 	unsigned int paned_userlist;
# Patch by Cyril Brulebois <cyril.brulebois@enst-bretagne.fr>
--- a/src/fe-gtk/fe-gtk.c
+++ b/src/fe-gtk/fe-gtk.c
@@ -934,18 +934,22 @@
 static void
 fe_open_url_inner (const char *url)
 {
+	char buf[256];
+
 #ifdef WIN32
 	ShellExecute (0, "open", url, NULL, NULL, SW_SHOWNORMAL);
 #else
 	/* universal desktop URL opener (from xdg-utils). Supports gnome,kde,xfce4. */
 	if (try_browser ("xdg-open", NULL, url))
 		return;
+	fprintf( stderr, "fe_open_url_inner: failed to open %s with xdg-open\n", url );
 
 	/* try to detect GNOME */
 	if (g_getenv ("GNOME_DESKTOP_SESSION_ID"))
 	{
 		if (try_browser ("gnome-open", NULL, url)) /* Gnome 2.4+ has this */
 			return;
+		fprintf( stderr, "fe_open_url_inner: failed to open %s with gnome-open\n", url );
 	}
 
 	/* try to detect KDE */
@@ -953,14 +957,21 @@
 	{
 		if (try_browser ("kfmclient", "exec", url))
 			return;
+		fprintf( stderr, "fe_open_url_inner: failed to open %s with kfmclient\n", url );
 	}
 
 	/* everything failed, what now? just try firefox */
 	if (try_browser ("firefox", NULL, url))
 		return;
+	fprintf( stderr, "fe_open_url_inner: failed to open %s with firefox\n", url );
+
+	if (try_browser ("mozilla", NULL, url))
+		return;
+	fprintf( stderr, "fe_open_url_inner: failed to open %s with mozilla\n", url );
 
 	/* fresh out of ideas... */
-	try_browser ("mozilla", NULL, url);
+	snprintf (buf, sizeof (buf), "Failed to open url:\n\n%s", url);
+	fe_message (buf, FE_MSG_ERROR);
 #endif
 }
 
## DP: write ignore.conf.bug463072 and rename to ignore.conf, fixes #463072.
--- a/src/common/cfgfiles.c
+++ b/src/common/cfgfiles.c
@@ -1093,6 +1093,20 @@
 		return open (buf, flags | OFLAGS);
 }
 
+int
+xchat_rename_file (char *oldpath, char *newpath, int xof_flags)
+{
+	char bufoldpath[1024];
+	char bufnewpath[1024];
+
+	if (xof_flags & XOF_FULLPATH)
+		return rename (oldpath, newpath);
+
+	snprintf (bufoldpath, sizeof (bufoldpath), "%s/%s", get_xdir_fs (), oldpath);
+	snprintf (bufnewpath, sizeof (bufnewpath), "%s/%s", get_xdir_fs (), newpath);
+	return rename (bufoldpath, bufnewpath);
+}
+
 FILE *
 xchat_fopen_file (const char *file, const char *mode, int xof_flags)
 {
--- a/src/common/cfgfiles.h
+++ b/src/common/cfgfiles.h
@@ -25,6 +25,7 @@
 void list_addentry (GSList ** list, char *cmd, char *name);
 int cmd_set (session *sess, char *tbuf, char *word[], char *word_eol[]);
 int xchat_open_file (char *file, int flags, int mode, int xof_flags);
+int xchat_rename_file (char *oldpath, char *newpath, int xof_flags);
 FILE *xchat_fopen_file (const char *file, const char *mode, int xof_flags);
 #define XOF_DOMODE 1
 #define XOF_FULLPATH 2
--- a/src/common/ignore.c
+++ b/src/common/ignore.c
@@ -304,11 +304,12 @@
 ignore_save ()
 {
 	char buf[1024];
-	int fh;
+	int fh, rc;
+	ssize_t nb;
 	GSList *temp = ignore_list;
 	struct ignore *ig;
 
-	fh = xchat_open_file ("ignore.conf", O_TRUNC | O_WRONLY | O_CREAT, 0600, XOF_DOMODE);
+	fh = xchat_open_file ("ignore.conf.bug463072", O_TRUNC | O_WRONLY | O_CREAT, 0600, XOF_DOMODE);
 	if (fh != -1)
 	{
 		while (temp)
@@ -318,11 +319,28 @@
 			{
 				snprintf (buf, sizeof (buf), "mask = %s\ntype = %d\n\n",
 							 ig->mask, ig->type);
-				write (fh, buf, strlen (buf));
+				nb = write (fh, buf, strlen (buf));
+				if( nb == (ssize_t)-1 )
+				{
+					perror( "ignore_save: write() failed" );
+					close( fh );
+					return;
+				}
 			}
 			temp = temp->next;
 		}
-		close (fh);
+		rc = close (fh);
+		if( rc != 0 )
+		{
+			perror( "ignore_save: close() failed" );
+			return;
+		}
+		rc = xchat_rename_file( "ignore.conf.bug463072", "ignore.conf", XOF_DOMODE );
+		if( rc != 0 )
+		{
+			perror( "ignore_save: xchat_rename_file() failed" );
+			return;
+		}
 	}
 
 }
## 45_brand_ctcp_version.dpatch by Daniel Holbach <daniel.holbach@ubuntu.com>
##
## All lines beginning with `## DP:' are a description of the patch.
## DP: Modify CTCP VERSION response to be branded with the Ubuntu name.

diff -urNad xchat-2.6.0~/src/common/ctcp.c xchat-2.6.0/src/common/ctcp.c
--- xchat-2.6.0~/src/common/ctcp.c	2005-10-21 11:50:58.000000000 +0200
+++ xchat-2.6.0/src/common/ctcp.c	2005-12-20 09:48:11.000000000 +0100
@@ -129,8 +129,7 @@
 
 	if (!strcasecmp (msg, "VERSION") && !prefs.hidever)
 	{
-		snprintf (outbuf, sizeof (outbuf), "VERSION xchat "PACKAGE_VERSION" %s",
-					 get_cpu_str ());
+		snprintf (outbuf, sizeof (outbuf), "VERSION xchat "PACKAGE_VERSION" Ubuntu");
 		serv->p_nctcp (serv, nick, outbuf);
 	}
 
## 46_CVE-2009-0315.dpatch by Nico Golde <nion@debian.org>
--- a/plugins/python/python.c
+++ b/plugins/python/python.c
@@ -1128,6 +1128,7 @@
 	}
 
 	PySys_SetArgv(1, argv);
+	PyRun_SimpleString("import sys; sys.path = filter(None, sys.path)");
 	PySys_SetObject("__plugin__", (PyObject *) plugin);
 
 	/* Set stdout and stderr to xchatout. */
@@ -2133,6 +2134,7 @@
 	Py_SetProgramName("xchat");
 	Py_Initialize();
 	PySys_SetArgv(1, argv);
+	PyRun_SimpleString("import sys; sys.path = filter(None, sys.path)");
 
 	Plugin_Type.ob_type = &PyType_Type;
 	Context_Type.ob_type = &PyType_Type;
## Patch by Santamar<ED>a Lema <panfaust@gmail.com>
--- a/src/common/proto-irc.c
+++ b/src/common/proto-irc.c
@@ -45,6 +45,7 @@
 {
 	if (serv->password[0])
 		tcp_sendf (serv, "PASS %s\r\n", serv->password);
+	tcp_sendf (serv, "CAP LS\r\n");
 
 	tcp_sendf (serv,
 				  "NICK %s\r\n"
@@ -1109,6 +1110,38 @@
 			return;
 		}
 	}
+
+	else if (len == 3)
+	{
+		guint32 t;
+
+		t = WORDL((guint8)type[0], (guint8)type[1], (guint8)type[2], (guint8)type[3]);
+		switch (t)
+		{
+		case WORDL('C','A','P','\0'):
+			if (strncasecmp(word[4], "ACK", 3) == 0)
+			{
+				if (strncasecmp(word[5][0]==':' ? word[5]+1 : word[5],
+					"identify-msg", 12) == 0)
+				{
+					serv->have_idmsg = TRUE;
+					tcp_send_len(serv, "CAP END\r\n", 9);
+				}
+			}
+			else if (strncasecmp(word[4], "LS", 2) == 0)
+			{
+				if (strstr(word_eol[5], "identify-msg") != 0)
+					tcp_send_len(serv, "CAP REQ :identify-msg\r\n", 23);
+				else
+					tcp_send_len(serv, "CAP END\r\n", 9);
+			}
+			else if (strncasecmp(word[4], "NAK",3) == 0)
+			{
+				tcp_send_len(serv, "CAP END\r\n", 9);
+			}
+			return;
+		}
+	}
 
 garbage:
 	/* unknown message */
## 52_fix_implicit_declaration.dpatch by Fabrice Coutadeur <fabricesp@ubuntu.com>
##
## Origin: http://lists.opensuse.org/opensuse-commit/2009-07/msg00981.html
## Description: Fix "implicitly converted to pointer at ignoregui.c:192" error.
## This fixes a FTBFS in ia64 and amd64
--- a/src/fe-gtk/ignoregui.c
+++ b/src/fe-gtk/ignoregui.c
@@ -36,6 +36,7 @@
 #include <gtk/gtkliststore.h>
 #include <gtk/gtktreeview.h>
 #include <gtk/gtktreeselection.h>
+#include <gtk/gtkcelllayout.h>
 #include <gtk/gtkcellrenderertext.h>
 #include <gtk/gtkcellrenderertoggle.h>
 
@@ -187,7 +188,7 @@
 	for (col_id=0; (col = gtk_tree_view_get_column (GTK_TREE_VIEW (view), col_id));
 	     col_id++)
 	{
-		GList *list = gtk_tree_view_column_get_cell_renderers (col);
+		GList *list = gtk_cell_layout_get_cells (GTK_CELL_LAYOUT (col));
 		GList *tmp;
 
 		for (tmp = list; tmp; tmp = tmp->next)
## Patch by <davian818@gmail.com>

=== modified file 'src/fe-gtk/plugin-tray.c'
--- old/src/fe-gtk/plugin-tray.c	2008-10-31 17:46:48 +0000
+++ new/src/fe-gtk/plugin-tray.c	2009-03-13 12:06:32 +0000
@@ -653,7 +653,7 @@
 	}
 
 	if (prefs.input_balloon_hilight)
-		tray_set_balloonf (word[2], _("XChat: Highlighted message from: %s (%s)"),
+		tray_set_balloonf (word[2], _("%s (%s)"),
 								 word[1], xchat_get_info (ph, "channel"));
 
 	return XCHAT_EAT_NONE;
@@ -678,8 +678,8 @@
 	}
 
 	if (prefs.input_balloon_chans)
-		tray_set_balloonf (word[2], _("XChat: New public message from: %s (%s)"),
-								 word[1], xchat_get_info (ph, "channel"));
+		tray_set_balloonf (word[2], _("%s (%s)"),
+								 word[1], xchat_get_info(ph, "channel"));
 
 	return XCHAT_EAT_NONE;
 }
@@ -707,8 +707,8 @@
 							tray_priv_count, from, network);
 
 	if (prefs.input_balloon_priv)
-		tray_set_balloonf (text, _("XChat: Private message from: %s (%s)"),
-								 from, network);
+		tray_set_balloonf (text, "%s",
+								 from);
 }
 
 static int
@@ -761,8 +761,8 @@
 	}
 
 	if (prefs.input_balloon_priv)
-		tray_set_balloonf ("", _("XChat: File offer from: %s (%s)"),
-								word[1], network);
+		tray_set_balloonf (_("is offering you a file."), "%s",
+								word[1]);
 
 	return XCHAT_EAT_NONE;
 }

Index: xchat-2.8.8/src/common/inbound.c
===================================================================
--- xchat-2.8.8.orig/src/common/inbound.c	2010-10-08 23:22:34.000000000 +0200
+++ xchat-2.8.8/src/common/inbound.c	2010-10-10 01:59:41.000000000 +0200
@@ -186,6 +186,9 @@
 
 	inbound_make_idtext (serv, idtext, sizeof (idtext), id);
 
+	if (alert_match_word (from, prefs.irc_no_hilight))
+		return;
+
 	sess = find_session_from_nick (from, serv);
 	if (!sess)
 	{
@@ -436,6 +439,9 @@
 
 	inbound_make_idtext (serv, idtext, sizeof (idtext), id);
 
+	if (alert_match_word (from, prefs.irc_no_hilight))
+		return;
+
 	if (is_hilight (from, text, sess, serv))
 		hilight = TRUE;
 
Description: Upstream changes introduced in version 2.8.8-3ubuntu6~test2
Author: Andreas Moog <amoog@ubuntu.com>
Bug: http://sourceforge.net/support/tracker.php?aid=3024423
Bug-Ubuntu: https://launchpad.net/bugs/392503

--- xchat-2.8.8.orig/src/fe-gtk/menu.c
+++ xchat-2.8.8/src/fe-gtk/menu.c
@@ -2215,8 +2215,10 @@ togitem:
 													 mymenu[i].state);*/
 			if (mymenu[i].key != 0)
 				gtk_widget_add_accelerator (item, "activate", accel_group,
-									mymenu[i].key, mymenu[i].id == MENU_ID_AWAY ?
-									away_mask : GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
+									mymenu[i].key,
+									mymenu[i].id == MENU_ID_AWAY ? away_mask :
+									mymenu[i].key == GDK_F9 ? 0 :
+									GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
 			if (mymenu[i].callback)
 				g_signal_connect (G_OBJECT (item), "toggled",
 										G_CALLBACK (mymenu[i].callback), 0);
diff -Nurp xchat-2.8.8/src/common/url.c working/src/common/url.c
--- xchat-2.8.8/src/common/url.c	2009-08-16 02:40:16.000000000 -0700
+++ working/src/common/url.c	2012-02-23 11:21:04.745059924 -0800
@@ -139,6 +139,7 @@ url_check_word (char *word, int len)
 		{ D("file://") },
 		{ D("rtsp://") },
 		{ D("ut2004://") },
+		{ D("apt:") },
 	},
 	suffix[] = {
 		{ D(".org") },
diff -Nurp xchat-2.8.8/src/fe-gtk/fe-gtk.c working/src/fe-gtk/fe-gtk.c
--- xchat-2.8.8/src/fe-gtk/fe-gtk.c	2012-02-23 11:18:22.000000000 -0800
+++ working/src/fe-gtk/fe-gtk.c	2012-02-23 11:22:42.129272865 -0800
@@ -979,7 +979,7 @@ static void
 fe_open_url_locale (const char *url)
 {
 #ifndef WIN32
-	if (url[0] != '/' && strchr (url, ':') == NULL)
+	if (url[0] != '/' && strchr (url, ':') == NULL && strncmp (url, "apt:", 4) != 0)
 	{
 		url = g_strdup_printf ("http://%s", url);
 		fe_open_url_inner (url);
## Description: Make it possible to open irc:// URI's via gvfs.
## Origin/Author: Shawn Landden <shawnlandden@gmail.com> and
## Daniel Gimpelevich <daniel@gimpelevich.san-francisco.ca.us>
## Bug: https://bugs.launchpad.net/ubuntu/+source/xchat/+bug/933822
Index: xchat-2.8.8/xchat.desktop
===================================================================
--- xchat-2.8.8.orig/xchat.desktop	2010-05-30 08:08:48.000000000 +0200
+++ xchat-2.8.8/xchat.desktop	2012-12-03 19:18:00.000000000 +0100
@@ -15,9 +15,10 @@
 Comment[ro]=Client de IRC
 Comment[zh_TW]=X-Chat 聊天程式
 Comment=Chat with other people using Internet Relay Chat
-Exec=xchat
+Exec=sh -c "xchat --existing --url %U || exec xchat"
 Icon=xchat
 Terminal=false
 Type=Application
 Categories=Network;
 StartupNotify=true
+MimeType=x-scheme-handler/irc;x-scheme-handler/ircs;
--- a/src/common/servlist.c
+++ b/src/common/servlist.c
@@ -24,7 +24,7 @@
 #include <unistd.h>
 
 #include "xchat.h"
-#include <glib/ghash.h>
+#include <glib.h>
 
 #include "cfgfiles.h"
 #include "fe.h"
--- a/src/common/text.c
+++ b/src/common/text.c
@@ -28,7 +28,7 @@
 #include <sys/mman.h>
 
 #include "xchat.h"
-#include <glib/ghash.h>
+#include <glib.h>
 #include "cfgfiles.h"
 #include "chanopt.h"
 #include "plugin.h"
--- a/src/common/util.c
+++ b/src/common/util.c
@@ -39,7 +39,7 @@
 #include <errno.h>
 #include "xchat.h"
 #include "xchatc.h"
-#include <glib/gmarkup.h>
+#include <glib.h>
 #include <ctype.h>
 #include "util.h"
 #include "../../config.h"
--- a/src/common/xchat.h
+++ b/src/common/xchat.h
@@ -1,10 +1,6 @@
 #include "../../config.h"
 
-#include <glib/gslist.h>
-#include <glib/glist.h>
-#include <glib/gutils.h>
-#include <glib/giochannel.h>
-#include <glib/gstrfuncs.h>
+#include <glib.h>
 #include <time.h>			/* need time_t */
 
 #ifndef XCHAT_H
